<apex:page standardController="NCR_Case__c"  extensions="NCR_ViewPageControllerX_V2">
<style>
textarea {
width: 75%;
}

select
{
custom style attributes
}
</style>

<script type="text/javascript">
function setFocusOnLoad() {} //prevent calendar control to be opened
function confirmSubmit(msg) {
      var confirmMsg = msg;  
      if(confirmMsg == '' || confirmMsg == 'null' ) return true;
      return confirm(confirmMsg);
}

    var newLookupWin=null;
    function openLookupPopup(buname, buid, pname, pid)
    {
        var url="/apex/NCR_ProjectPopup?namefieldBU=" + buname+ "&idfieldBU=" + buid + "&namefieldP=" + pname + "&idfieldP=" + pid;
        newLookupWin=window.open(url, 'Popup','height=500,width=600,left=100,top=100,resizable=no,scrollbars=yes,toolbar=no,status=no');
        if (window.focus) 
        {
            newLookupWin.focus();
        }
            
        return false;
    }
                  
    function closeLookupPopup()
    {
       if (null!=newLookupWin)
       {
          newLookupWin.close();
       }  
    } 

</script>
<apex:form >

        <apex:pageMessages id="errors" escape="false" />
        <apex:pageBlock id="viewsection" mode="maindetail" rendered="{!workflowEngine.ViewMode}"  title="{!workflowEngine.ViewScreenDescription}">
            <chatter:feedWithFollowers entityId="{!NCR_Case__c.id}"/>

            <apex:pageBlockButtons rendered="{!workflowEngine.ViewMode}" location="top">            
                <apex:outputPanel rendered="{!workflowEngine.userHasEditAccess}">
                
                <apex:commandButton action="{!workflowEngine.NCR_Action1}" 
                    onclick="return confirmSubmit('{!workflowEngine.CurrentNCRState.NCR_StateActions__r[0].Confirmation_Message__c}');" 
                    value="{!workflowEngine.CurrentNCRState.NCR_StateActions__r[0].NCR_Action__r.Name}" 
                    rendered="{!workflowEngine.ActionCount>0}"/>
                <apex:commandButton action="{!workflowEngine.NCR_Action2}" 
                    onclick="return confirmSubmit('{!workflowEngine.CurrentNCRState.NCR_StateActions__r[1].Confirmation_Message__c}');" 
                    value="{!workflowEngine.CurrentNCRState.NCR_StateActions__r[1].NCR_Action__r.Name}" 
                    rendered="{!workflowEngine.ActionCount>1}"/>          
                <apex:commandButton action="{!workflowEngine.NCR_Action3}" 
                    onclick="return confirmSubmit('{!workflowEngine.CurrentNCRState.NCR_StateActions__r[2].Confirmation_Message__c}');" 
                    value="{!workflowEngine.CurrentNCRState.NCR_StateActions__r[2].NCR_Action__r.Name}" 
                    rendered="{!workflowEngine.ActionCount>2}"/>  
                <apex:commandButton action="{!workflowEngine.NCR_Action4}" 
                    onclick="return confirmSubmit('{!workflowEngine.CurrentNCRState.NCR_StateActions__r[3].Confirmation_Message__c}');" 
                    value="{!workflowEngine.CurrentNCRState.NCR_StateActions__r[3].NCR_Action__r.Name}" 
                    rendered="{!workflowEngine.ActionCount>3}"/> 
                     
                                                  
                <!-- special button to notify QA Lead -->
                <!--
                <apex:commandButton action="{!NCR_NotifyQALead}" value="Notify QA Lead" title="Notify QA Lead" rendered="{!NCR_Case__c.NCR_Case_State__c=='Submitted'}"/> 
                -->
                &nbsp; &nbsp; &nbsp;
                
                <apex:commandButton action="{!NCR_AdminEdit}" value="Admin Edit" rendered="{!workflowEngine.UserHasAllAccess}"/> 
                <apex:commandButton action="{!URLFOR($Action.NCR_Case__c.Share,NCR_Case__c.Id)}" value="Share" rendered="{!workflowEngine.UserHasAllAccess}"/>
                
                </apex:outputPanel>
                <apex:outputPanel >
                <apex:commandButton action="{!NCR_CasesClone}" value="Copy"/> <!-- rendered="{!workflowEngine.UserHasAllAccess}" -->
                </apex:outputPanel>
                <apex:commandLink styleClass="btn" style="text-decoration:none" action="{!NCR_Pdf}" value="Print" target="_blank" id="printButton" />    
                
                <!-- Exit from the form and redirect to the list-->
                <apex:commandButton action="{!NCR_Exit}" value="Exit"/>                
            </apex:pageBlockButtons>  


            <!-- Display sections based on state of a NCR -->            
            <apex:repeat value="{!workflowEngine.viewScreenStateList}" var="m">
                <apex:pageBlockSection rendered="{!IF(workflowEngine.portalUser && workflowEngine.viewScreenStateMap[m]='Disposition Summary',false,true)}" title="{!workflowEngine.viewScreenStateMap[m]}" columns="2">
                    <apex:repeat value="{!$ObjectType.NCR_Case__c.FieldSets[m]}" var="f">
                        <apex:outputField value="{!NCR_Case__c[f]}" /><br/>
                    </apex:repeat>                
                </apex:pageBlockSection>       
            </apex:repeat>
        </apex:pageBlock>
       
        <apex:pageBlock id="editsection" mode="Edit" rendered="{!NOT(workflowEngine.ViewMode)}"  >
 
            <apex:pageBlockButtons rendered="{!NOT(workflowEngine.ViewMode)}">
                <apex:commandButton action="{!NCR_Save}" value="{!workflowEngine.SaveButtonLabel}" rendered="{!NOT(workflowEngine.ViewMode)}"/>
                <apex:commandButton action="{!NCR_CancelEdit}" immediate="true" value="Cancel" rendered="{!NOT(workflowEngine.ViewMode)}"/>                                      
            </apex:pageBlockButtons>

            <!-- Generic section to change NCR State -->
            <apex:pageBlocksection columns="1" rendered="{!OR(workflowEngine.btnChangeStateClicked, NOT(workflowEngine.ViewMode))}" title="{!workflowEngine.EditSectionName}">
                
                 <!-- NCR Related Suppliers and Their respective Assignees -->
                <apex:pageBlockSectionItem >
                    <apex:outputLabel value="Supplier" for="supplierName"/>
                    <apex:actionRegion >
                        <apex:pageBlockSectionItem >
                            <apex:outputPanel id="supplierNamePanel" layout="block" styleClass="requiredInput">
                                <apex:outputPanel styleClass="requiredBlock"/>
                                <apex:selectList size="1" multiselect="false" value="{!selectedSupplier}" label="Supplier Name">
                                    <apex:selectOptions value="{!NCRSuppliers}"/>
                                    <apex:actionSupport reRender="assigneePanel" event="onchange"/>
                                </apex:selectList>
                            </apex:outputPanel> 
                        </apex:pageBlockSectionitem>  
                    </apex:actionRegion>
                </apex:pageBlockSectionitem>
                
                <apex:pageBlockSectionItem >
                    <apex:outputLabel value="Assignee" for="assigneeName"/>
                    <apex:outputPanel id="assigneePanel" layout="block" styleClass="requiredInput">
                        <apex:outputPanel styleClass="requiredBlock"/>
                        <apex:selectList size="1" multiselect="false" value="{!selectedAssignee}" label="Assignee Name">
                            <apex:selectOptions value="{!NCRSupplierAssignees}"/>
                        </apex:selectList> 
                    </apex:outputPanel>                   
                </apex:pageBlockSectionitem>
                   
                <apex:pageBlockSectionItem >
                    <apex:outputLabel value="Business Unit" for="buName"/>
                    <apex:actionRegion >
                        <apex:pageBlockSectionItem >
                            <apex:outputPanel id="businessUnitPanel" layout="block" styleClass="requiredInput">
                                <apex:outputPanel styleClass="requiredBlock"/>
                                <apex:selectList disabled="{!IF(NCR_Case__c.NCR_Case_State__c = 'Disposition Plan Pending' || NCR_Case__c.NCR_Case_State__c = 'Disposition Plan Modification Requested' || NCR_Case__c.NCR_Case_State__c = 'Disposition Plan Implementation Pending', true, false)}" 
                                        size="1" multiselect="false" value="{!currentBU}" required="true" label="Business Unit">
                                    <apex:selectOptions value="{!BusinessUnits}"/>
                                    <apex:actionSupport reRender="projectPanel" event="onchange"/>
                                </apex:selectList>
                            </apex:outputPanel> 
                        </apex:pageBlockSectionitem>  
                    </apex:actionRegion>
                </apex:pageBlockSectionitem>
           
                <apex:pageBlockSectionItem >
                    <apex:outputLabel value="Project" for="projName"/>
                    <apex:outputPanel id="projectPanel" layout="block" styleClass="requiredInput">
                        <apex:outputPanel styleClass="requiredBlock"/>
                        <apex:selectList disabled="{!IF(NCR_Case__c.NCR_Case_State__c = 'Disposition Plan Pending' || NCR_Case__c.NCR_Case_State__c = 'Disposition Plan Modification Requested' || NCR_Case__c.NCR_Case_State__c = 'Disposition Plan Implementation Pending', true, false)}"
                                size="1" multiselect="false" value="{!currentProj}" required="true" label="Project">
                            <apex:selectOptions value="{!Projects}"/>
                        </apex:selectList> 
                    </apex:outputPanel>                   
                </apex:pageBlockSectionitem>     
                       
               <!-- We have to render all fields from the fieldset as inputfields except BU and Project lookups-->    
                <apex:repeat value="{!$ObjectType.NCR_Case__c.FieldSets[workflowEngine.FieldSetName]}" var="f">  
                
                    <apex:inputField value="{!NCR_Case__c[f]}" required="{!f.Required}" style="width:75%"  rendered="{!f='Short_Description_of_Non_Conformance__c'}"  />
                    <apex:inputField value="{!NCR_Case__c[f]}" style="width:75%"  rendered="{!f='Cause_of_nonconformance__c'}"  />
                    <apex:inputTextarea value="{!NCR_Case__c[f]}" richText="true" disabled="{!IF(NCR_Case__c.NCR_Case_State__c = 'Disposition Plan Pending', true, false)}" rendered="{!f='Proposed_Correction_Plan_Detail__c'}"  />
                    <apex:inputField value="{!NCR_Case__c[f]}" required="{!f.Required}" rendered="{!AND( f != 'Assignee__c', f != 'Project__c', f != 'Business_Unit_Lookup__c', f != 'Short_Description_of_Non_Conformance__c', f != 'Cause_of_nonconformance__c', f != 'Proposed_Correction_Plan_Detail__c')}"/>

               </apex:repeat>               
            </apex:pageBlocksection>
        </apex:pageBlock>
        
        <!--
        <apex:pageBlock title="Add New Attachments" mode="Edit" rendered="{!AND(ISPICKVAL($User.UserType,'Standard'),NOT(workflowEngine.ViewMode))}">
           <apex:pageBlocksection columns="1">
               <apex:pageBlockSectionItem >
               <apex:actionRegion >
                   
                <apex:inputFile value="{!documentFile.Body}" filename="{!documentFile.Name}" styleclass="btn" />
                    <apex:pageBlockSectionItem >
                        <apex:commandButton value="Upload File" action="{!uploadFile}"  />
                        <apex:actionSupport reRender="uploadPanel" event="uploadFile"/>
                    </apex:pageBlockSectionitem>                         
               </apex:actionRegion>
               </apex:pageBlockSectionitem>
                   
               <apex:pageBlockSectionItem >
                   <apex:outputPanel id="uploadPanel" layout="block">                        
                        <apex:pageBlockTable id="documentlist" value="{!documentList}" var="a">
                            <apex:column headerValue="Action" width="5%">
                                <apex:outputLink value="{!URLFOR($Action.Document.Download, a.id)}" target="_blank" style="color: blue;" rendered="{!a.id!=null}">
                                    View
                                </apex:outputLink> 
                                &nbsp;&nbsp;
                                <apex:actionRegion >
                                    <apex:commandLink value="Del" reRender="uploadPanel" immediate="true" onclick="if(!confirm('Are you sure you want to delete this attachment?')) return;" action="{!removeFile}" style="color: blue;">
                                        <apex:param name="attachmentid" value="{!a.id}" assignTo="{!SelectedAttachmentId}"/>
                                    </apex:commandLink>
                                </apex:actionRegion>                                        
                            </apex:column>
                            
                            <apex:column headerValue="Name">
                                <apex:outputText value="{!a.Name}"/>   
                            </apex:column>                                                         
                            
                        </apex:pageBlockTable>
                    </apex:outputPanel>
                
                </apex:pageBlockSectionitem>                       
               
            </apex:pageBlocksection>                                  
        </apex:pageBlock>
        -->            
        
</apex:form>    
      <apex:relatedList subject="{!NCR_Case__c}" list="CombinedAttachments" rendered="{!AND(workflowEngine.ViewMode,ISPICKVAL($User.UserType,'Standard'))}"/>
      
      <apex:relatedList subject="{!NCR_Case__c}" list="CombinedAttachments"  rendered="{!AND(workflowEngine.ViewMode,NOT(ISPICKVAL($User.UserType,'Standard')))}" />
</apex:page>